$COMMAND
srchdynm
*(SRCHDYNM.APP                      by Paul Litwin         07/29/90  )
*(For R:BASE version 3.0.                                            )
*(This application requests a last name, calls the SOUNDEX.CMD       )
*(routine to convert the name to its Soundex code, and presents the  )
*(user with a scrollable list of all similarly sounding names in the )
*(database.  It is set up to work with the PATIENT table of the      )
*(CLINIC database.  It could easily be adapted to work with other    )
*(databases where records are primarily located by last name and     )
*(misspellings may occur.                                            )
 
*(The PATIENT table of the CLINIC database could be created with the )
*(following command:                                                 )
*(CREATE TABLE patient idnum INTEGER, firname TEXT 20, +             )
*(  lasname TEXT 20, address TEXT 40, city TEXT 20, state TEXT 2, +  )
*(  zipcode INTEGER, areacode TEXT 3, phonenum TEXT 8, age INTEGER, +)
*(  sex TEXT 1, soundex TEXT 4                                       )
 
*(Local variables:                                                   )
*(    vlname   = surname to be searched for.                         )
*(    vlen     = length of vlname.                                   )
*(    vmatch   = number of records found with same Soundex code.     )
*(    vaction  = response of user to FILLIN command.                 )
*(    vid      = ID# selected by user.                               )
 
*(Routines called:                                                   )
*(    soundex.cmd  : Routine to compute soundex code.  See Sept '90  )
*(                   issue of Data Based Advisor.                    )
*(                   Variables passed: vlname, vlen.                 )
 
 
SET QUOTE ="
LABEL startcmd
 
CLS
SET V vlname TEXT +
      vlen INTEGER +
      vmatch INTEGER +
      vaction TEXT
 
SET MESSAGES OFF
SET ERROR MESSAGES OFF
SET ESC OFF
SET BELL OFF
 
*(Request last name and compute length.                              )
DISPLAY getname IN srchdynm.apx AT 16
FILLIN vlname USING "[" AT 18,50
SET V vlen TO (SLEN(.vlname))
 
*(If length = 0, then null repsonse, so quit routine.                )
IF vlen = 0 THEN
  GOTO abortcmd
ENDIF
 
*(Compute soundex code for vlname.                                   )
RUN soundex.cmd
 
*(Compute the number of records with the same soundex value.         )
CLS
WRITE "Standby while searching..." AT 1,40
COMPUTE vmatch AS COUNT idnum FROM patient WHERE soundex = .vsdx
 
*(If no matches found, then enter a new patient record.              )
IF vmatch = 0 THEN
  DISPLAY nomatch IN srchdynm.apx AT 13
  PAUSE
  ENTER ptvisit FOR 1 ROW
  GOTO startcmd
ENDIF
 
*(Since we found at least one match, we must now display the matches )
*(so the user can determine if any of the potential matches are      )
*(the patient we are looking for.                                    )
CLS
WRITE "Select matching pt & hit [Enter] or hit [Esc] for no match" +
  AT 1,5
WRITE "Use [PgUp] and [PgDn] keys to scroll the screen" AT 2,5
CHOOSE vchoice FROM #VALUES FOR +
  (CTXT(idnum) + "," & firname & lasname + "," & address +
  + "," & city + "," & sex + "," & CTXT(age)) +
  FROM patient WHERE soundex = .vsdx ORDER BY firname +
  AT 3,1 FOOTING
 
IF vchoice = "[Esc]" THEN
  SET V vid INTEGER
  SET V vid = 0
  ENTER ptvisit FOR 1 ROW
ELSE
  SET V vid TEXT
  SET V vid = (SSUB(.vchoice,1))
  SET V vid INTEGER
  EDIT USING ptvisit WHERE idnum = .vid
ENDIF
 
 
*(Go back to beginning to request another patient name.              )
GOTO startcmd
 
 
LABEL abortcmd
 
CLEAR VAR vid vlname vmatch vlen vaction vchoice vsdx
RETURN
$SCREEN
getname
Ŀ
        Enter Last Name of patient                                      
        or leave blank to quit.                 [                    ]  

$SCREEN
nomatch
          ͻ
                                           
                  No matches found.        
                                           
          Hit any key to continueͼ
           
