* TS.PRG
PARAMETERS _parent, _relatkey, _child, _ntxname

IF PCOUNT() < 4
    ? "Usage: TESTSCRL parent_file key child_file index_name"
    QUIT
ENDIF

IF !FILE( _parent + ".DBF" )      && Is parent file there?
    ? "Cannot find " + _parent + ".DBF"
    QUIT
ENDIF
IF !FILE( _child + ".DBF" )       && Is child file there?
    ? "Cannot find " + _child + ".DBF"
    QUIT
ENDIF
IF !FILE( _ntxname + ".NTX" )     && Is index there?
    ? "Cannot find " + _ntxname + ".NTX"
    QUIT
ENDIF

SET EXACT OFF
SELECT 0                          && Open the parent file.
USE ( _parent )

SELECT 0                          && Open the child file.
USE ( _child ) INDEX &_ntxname

IF UPPER( INDEXKEY( 0 )) != UPPER( _relatkey )
    ? _relatkey + " and " + _ntxname + " key do not match."
    QUIT
ENDIF

@ 0, 0 CLEAR

SELECT ( SELECT( _parent ))
KEYBOARD " "
DBEDIT( 0, 0, 23, 79, .F., "CALL_KSCRL" )
@ 23, 0
RETURN



*  *
FUNCTION CALL_KSCRL                 && Inner UDF for DBEDIT()
PARAMETERS mode, fld_ptr            && to call K_SCROLL().
*  *
PRIVATE _result, _row, _col, keystroke

_result   = 1                       && Default = no-repaint.
keystroke = LASTKEY()
_row      = ROW()                   && A little user-friendliness,
_col      = COL()                   && but not too much.
@ 24, 0 SAY SPACE( 9 ) + ;
        "To scroll the kids if any, press <ENTER>. " + ;
        "Back out with <ESC>." + SPACE( 10 )
@ _row, _col SAY ""

IF mode = 4                         && Exception
    IF M->keystroke = 13            && <ENTER> -> K_SCROLL().
        @ 24, 0
        K_SCROLL( _parent, _relatkey, _child )
        _result = 2                 && Repaint
    ELSEIF M->keystroke = 27
        _result = 0                 && Out
    ENDIF
ENDIF

RETURN _result

